Workflow List

Workflow List is a type of drop-down in SpreadJS, which is defined in JavaScript code as a cell style in the workbook. The developer can specify the items of the list and the items that they transition to when the user selects them. Try selecting different items in the Workflow List in the spreadsheet below to see how the options change.

Description
app.vue
index.html
Copy to CodeMine

Drop-downs provide developers the ability to add a drop-down menu with specific properties to cells in a workbook. These drop-down menus don't require any extra code other than simply specifying which one to use for the drop-down menu.

SpreadJS has 9 different kinds of drop-downs, and this demo shows how to use the Workflow List.

Before opening the Workflow List, you need to set the options data in cell's style. You can use Workflow List drop-down with the following code :

    // The way of click the dropdown icon to open Workflow List. 
   let style = new GC.Spread.Sheets.Style();
       style.cellButtons = [
           {
               imageType: GC.Spread.Sheets.ButtonImageType.dropdown,
               command: "openWorkflowList",
               useButtonStyle: true,
           }
       ];
       style.dropDowns = [
           {
               type: GC.Spread.Sheets.DropDownType.workflowList,
               option: {
                   items: [
                       { value: "New", transitions: [1] },
                       { value: "Open",transitions: [0,2,3,5] },
                       { value: "In Progress", transitions: [1, 3, 5] },
                       { value: "Resolved", transitions: [5, 4] },
                       { value: "Reopened",transitions: [5, 3, 2] },
                       { value: "Closed", transitions: [4] },
                   ]
               }
           }
       ];
       sheet.setText(4, 4, "Workflow List");
       sheet.setStyle(5, 4, style);

       // The way just open Workflow List with command rather then clicking the dropdown button.
       spread.commandManager().execute({cmd:"openWorkflowList",row:5,col:4,sheetName:"Sheet1"});

The option of Workflow List should follow the structure like this :

export interface IWorkFlowOption {
    items: IWorkFlowItem[];
}


export interface IWorkFlowItem {
    value: string;
    transitions: number[]|string[];
}
Drop-downs provide developers the ability to add a drop-down menu with specific properties to cells in a workbook. These drop-down menus don't require any extra code other than simply specifying which one to use for the drop-down menu. SpreadJS has 9 different kinds of drop-downs, and this demo shows how to use the Workflow List. Before opening the Workflow List, you need to set the options data in cell's style. You can use Workflow List drop-down with the following code : The option of Workflow List should follow the structure like this :
<template> <div class="sample-tutorial"> <gc-spread-sheets class="sample-spreadsheets" @workbookInitialized="initSpread"> </gc-spread-sheets> </div> </template> <script setup> import '@mescius/spread-sheets-vue' import { ref } from "vue"; import GC from "@mescius/spread-sheets"; const spreadRef = ref(null); function initSpread(spread) { spreadRef.value = spread; let sheet = spread.getSheet(0); sheet.suspendPaint(); // -------------------- WorkFlow --------------------- let style = new GC.Spread.Sheets.Style(); style.cellButtons = [{ imageType: GC.Spread.Sheets.ButtonImageType.dropdown, command: "openWorkflowList", useButtonStyle: true, }]; style.dropDowns = [{ type: GC.Spread.Sheets.DropDownType.workflowList, option: { items: [{ value: "New", transitions: [1] }, { value: "Open", transitions: [0, 2, 3, 5] }, { value: "In Progress", transitions: [1, 3, 5] }, { value: "Resolved", transitions: [5, 4] }, { value: "Reopened", transitions: [5, 3, 2] }, { value: "Closed", transitions: [4] }, ] } }]; sheet.setText(4, 4, "Workflow List"); sheet.setStyle(5, 4, style); sheet.resumePaint(); spread.commandManager().execute({ cmd: "openWorkflowList", row: 5, col: 4, sheetName: "Sheet1" }); } </script> <style scoped> .sample-tutorial { position: relative; height: 100%; overflow: hidden; } .sample-spreadsheets { width: 100%; height: 100%; overflow: hidden; float: left; } body { position: absolute; top: 0; bottom: 0; left: 0; right: 0; } </style>
<!DOCTYPE html> <html style="height:100%;font-size:14px;"> <head> <meta charset="utf-8" /> <meta http-equiv="X-UA-Compatible" content="IE=edge" /> <title>SpreadJS VUE</title> <meta name="viewport" content="width=device-width, initial-scale=1.0" /> <link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/vue3/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css"> <script src="$DEMOROOT$/en/vue3/node_modules/systemjs/dist/system.src.js"></script> <script src="./systemjs.config.js"></script> <script src="./compiler.js" type="module"></script> <script> var System = SystemJS; System.import("./src/app.js"); System.import('$DEMOROOT$/en/lib/vue3/license.js'); </script> </head> <body> <div id="app" style="height: 100%;"></div> </body> </html>
(function (global) { SystemJS.config({ transpiler: 'plugin-babel', babelOptions: { es2015: true }, paths: { // paths serve as alias 'npm:': 'node_modules/' }, packageConfigPaths: [ './node_modules/*/package.json', "./node_modules/@mescius/*/package.json", "./node_modules/@babel/*/package.json", "./node_modules/@vue/*/package.json" ], map: { '@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js', '@mescius/spread-sheets-io': 'npm:@mescius/spread-sheets-io/index.js', '@mescius/spread-sheets-vue': 'npm:@mescius/spread-sheets-vue/index.js', 'vue': "npm:vue/dist/vue.esm-browser.js", 'tiny-emitter': 'npm:tiny-emitter/index.js', 'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js', "systemjs-babel-build": "npm:systemjs-plugin-babel/systemjs-babel-browser.js", }, meta: { '*.css': { loader: 'systemjs-plugin-css' }, '*.vue': { loader: "../plugin-vue/index.js" } } }); })(this);

Workflow List

Workflow List is a type of drop-down in SpreadJS, which is defined in JavaScript code as a cell style in the workbook. The developer can specify the items of the list and the items that they transition to when the user selects them. Try selecting different items in the Workflow List in the spreadsheet below to see how the options change.

Description
app.jsx
app-func.jsx
app-class.jsx
index.html
styles.css
Copy to CodeMine

Drop-downs provide developers the ability to add a drop-down menu with specific properties to cells in a workbook. These drop-down menus don't require any extra code other than simply specifying which one to use for the drop-down menu.

SpreadJS has 9 different kinds of drop-downs, and this demo shows how to use the Workflow List.

Before opening the Workflow List, you need to set the options data in cell's style. You can use Workflow List drop-down with the following code :

    // The way of click the dropdown icon to open Workflow List. 
   let style = new GC.Spread.Sheets.Style();
       style.cellButtons = [
           {
               imageType: GC.Spread.Sheets.ButtonImageType.dropdown,
               command: "openWorkflowList",
               useButtonStyle: true,
           }
       ];
       style.dropDowns = [
           {
               type: GC.Spread.Sheets.DropDownType.workflowList,
               option: {
                   items: [
                       { value: "New", transitions: [1] },
                       { value: "Open",transitions: [0,2,3,5] },
                       { value: "In Progress", transitions: [1, 3, 5] },
                       { value: "Resolved", transitions: [5, 4] },
                       { value: "Reopened",transitions: [5, 3, 2] },
                       { value: "Closed", transitions: [4] },
                   ]
               }
           }
       ];
       sheet.setText(4, 4, "Workflow List");
       sheet.setStyle(5, 4, style);

       // The way just open Workflow List with command rather then clicking the dropdown button.
       spread.commandManager().execute({cmd:"openWorkflowList",row:5,col:4,sheetName:"Sheet1"});

The option of Workflow List should follow the structure like this :

export interface IWorkFlowOption {
    items: IWorkFlowItem[];
}


export interface IWorkFlowItem {
    value: string;
    transitions: number[]|string[];
}
Drop-downs provide developers the ability to add a drop-down menu with specific properties to cells in a workbook. These drop-down menus don't require any extra code other than simply specifying which one to use for the drop-down menu. SpreadJS has 9 different kinds of drop-downs, and this demo shows how to use the Workflow List. Before opening the Workflow List, you need to set the options data in cell's style. You can use Workflow List drop-down with the following code : The option of Workflow List should follow the structure like this :
import * as React from 'react'; import * as ReactDOM from 'react-dom'; import './styles.css'; import { AppFunc } from './app-func'; // import { App } from './app-class'; // 1. Functional Component sample ReactDOM.render(<AppFunc />, document.getElementById('app')); // 2. Class Component sample // ReactDOM.render(<App />, document.getElementById('app'));
import * as React from 'react'; import GC from '@mescius/spread-sheets'; import { SpreadSheets } from '@mescius/spread-sheets-react'; export function AppFunc() { const initSpread = (spread) => { let sheet = spread.getSheet(0); sheet.suspendPaint(); // -------------------- WorkFlow --------------------- let style = new GC.Spread.Sheets.Style(); style.cellButtons = [ { imageType: GC.Spread.Sheets.ButtonImageType.dropdown, command: "openWorkflowList", useButtonStyle: true, } ]; style.dropDowns = [ { type: GC.Spread.Sheets.DropDownType.workflowList, option: { items: [ { value: "New", transitions: [1] }, { value: "Open", transitions: [0, 2, 3, 5] }, { value: "In Progress", transitions: [1, 3, 5] }, { value: "Resolved", transitions: [5, 4] }, { value: "Reopened", transitions: [5, 3, 2] }, { value: "Closed", transitions: [4] }, ] } } ]; sheet.setText(4, 4, "Workflow List"); sheet.setStyle(5, 4, style); sheet.resumePaint(); spread.commandManager().execute({ cmd: "openWorkflowList", row: 5, col: 4, sheetName: "Sheet1" }); } return (<div class="sample-tutorial"> <div class="sample-spreadsheets"> <SpreadSheets workbookInitialized={initSpread}> </SpreadSheets> </div> </div>); }
import * as React from 'react'; import GC from '@mescius/spread-sheets'; import { SpreadSheets } from '@mescius/spread-sheets-react'; const Component = React.Component; export class App extends Component { constructor(props) { super(props); this.spread = null; this.autoGenerateColumns = false; } render() { return (<div class="sample-tutorial"> <div class="sample-spreadsheets"> <SpreadSheets workbookInitialized={spread => this.initSpread(spread)}> </SpreadSheets> </div> </div>); } initSpread(spread) { let sheet = spread.getSheet(0); sheet.suspendPaint(); // -------------------- WorkFlow --------------------- let style = new GC.Spread.Sheets.Style(); style.cellButtons = [ { imageType: GC.Spread.Sheets.ButtonImageType.dropdown, command: "openWorkflowList", useButtonStyle: true, } ]; style.dropDowns = [ { type: GC.Spread.Sheets.DropDownType.workflowList, option: { items: [ { value: "New", transitions: [1] }, { value: "Open",transitions: [0,2,3,5] }, { value: "In Progress", transitions: [1, 3, 5] }, { value: "Resolved", transitions: [5, 4] }, { value: "Reopened",transitions: [5, 3, 2] }, { value: "Closed", transitions: [4] }, ] } } ]; sheet.setText(4, 4, "Workflow List"); sheet.setStyle(5, 4, style); sheet.resumePaint(); spread.commandManager().execute({cmd:"openWorkflowList",row:5,col:4,sheetName:"Sheet1"}); } }
<!doctype html> <html style="height:100%;font-size:14px;"> <head> <meta charset="utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0" /> <link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/react/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css"> <!-- SystemJS --> <script src="$DEMOROOT$/en/react/node_modules/systemjs/dist/system.src.js"></script> <script src="systemjs.config.js"></script> <script> System.import('$DEMOROOT$/en/lib/react/license.js').then(function () { System.import('./src/app'); }); </script> </head> <body> <div id="app"></div> </body> </html>
.sample-tutorial { position: relative; height: 100%; overflow: hidden; } .sample-spreadsheets { width: 100%; height: 100%; overflow: hidden; float: left; } body { position: absolute; top: 0; bottom: 0; left: 0; right: 0; } #app { height: 100%; }
(function (global) { System.config({ transpiler: 'plugin-babel', babelOptions: { es2015: true, react: true }, meta: { '*.css': { loader: 'css' } }, paths: { // paths serve as alias 'npm:': 'node_modules/' }, // map tells the System loader where to look for things map: { '@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js', '@mescius/spread-sheets-react': 'npm:@mescius/spread-sheets-react/index.js', '@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js', 'react': 'npm:react/umd/react.production.min.js', 'react-dom': 'npm:react-dom/umd/react-dom.production.min.js', 'css': 'npm:systemjs-plugin-css/css.js', 'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js', 'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js' }, // packages tells the System loader how to load when no filename and/or no extension packages: { src: { defaultExtension: 'jsx' }, "node_modules": { defaultExtension: 'js' }, } }); })(this);

Workflow List

Workflow List is a type of drop-down in SpreadJS, which is defined in JavaScript code as a cell style in the workbook. The developer can specify the items of the list and the items that they transition to when the user selects them. Try selecting different items in the Workflow List in the spreadsheet below to see how the options change.

Description
app.component.ts
index.html
app.component.html
styles.css
Copy to CodeMine

Drop-downs provide developers the ability to add a drop-down menu with specific properties to cells in a workbook. These drop-down menus don't require any extra code other than simply specifying which one to use for the drop-down menu.

SpreadJS has 9 different kinds of drop-downs, and this demo shows how to use the Workflow List.

Before opening the Workflow List, you need to set the options data in cell's style. You can use Workflow List drop-down with the following code :

    // The way of click the dropdown icon to open Workflow List. 
   let style = new GC.Spread.Sheets.Style();
       style.cellButtons = [
           {
               imageType: GC.Spread.Sheets.ButtonImageType.dropdown,
               command: "openWorkflowList",
               useButtonStyle: true,
           }
       ];
       style.dropDowns = [
           {
               type: GC.Spread.Sheets.DropDownType.workflowList,
               option: {
                   items: [
                       { value: "New", transitions: [1] },
                       { value: "Open",transitions: [0,2,3,5] },
                       { value: "In Progress", transitions: [1, 3, 5] },
                       { value: "Resolved", transitions: [5, 4] },
                       { value: "Reopened",transitions: [5, 3, 2] },
                       { value: "Closed", transitions: [4] },
                   ]
               }
           }
       ];
       sheet.setText(4, 4, "Workflow List");
       sheet.setStyle(5, 4, style);

       // The way just open Workflow List with command rather then clicking the dropdown button.
       spread.commandManager().execute({cmd:"openWorkflowList",row:5,col:4,sheetName:"Sheet1"});

The option of Workflow List should follow the structure like this :

export interface IWorkFlowOption {
    items: IWorkFlowItem[];
}


export interface IWorkFlowItem {
    value: string;
    transitions: number[]|string[];
}
Drop-downs provide developers the ability to add a drop-down menu with specific properties to cells in a workbook. These drop-down menus don't require any extra code other than simply specifying which one to use for the drop-down menu. SpreadJS has 9 different kinds of drop-downs, and this demo shows how to use the Workflow List. Before opening the Workflow List, you need to set the options data in cell's style. You can use Workflow List drop-down with the following code : The option of Workflow List should follow the structure like this :
import { Component, NgModule, enableProdMode } from '@angular/core'; import { BrowserModule } from '@angular/platform-browser'; import { platformBrowserDynamic } from '@angular/platform-browser-dynamic'; import { SpreadSheetsModule } from '@mescius/spread-sheets-angular'; import GC from '@mescius/spread-sheets'; import './styles.css'; @Component({ selector: 'app-component', templateUrl: 'src/app.component.html' }) export class AppComponent { hostStyle = { width: '100%', height: '100%', overflow: 'hidden', float: 'left' }; initSpread($event: any) { let spread = $event.spread; let sheet = spread.getSheet(0); sheet.suspendPaint(); // -------------------- WorkFlow --------------------- let style = new GC.Spread.Sheets.Style(); style.cellButtons = [{ imageType: GC.Spread.Sheets.ButtonImageType.dropdown, command: "openWorkflowList", useButtonStyle: true, }]; style.dropDowns = [{ type: GC.Spread.Sheets.DropDownType.workflowList, option: { items: [{ value: "New", transitions: [1] }, { value: "Open", transitions: [0, 2, 3, 5] }, { value: "In Progress", transitions: [1, 3, 5] }, { value: "Resolved", transitions: [5, 4] }, { value: "Reopened", transitions: [5, 3, 2] }, { value: "Closed", transitions: [4] }, ] } }]; sheet.setText(4, 4, "Workflow List"); sheet.setStyle(5, 4, style); sheet.resumePaint(); spread.commandManager().execute({ cmd: "openWorkflowList", row: 5, col: 4, sheetName: "Sheet1" }); } } @NgModule({ imports: [BrowserModule, SpreadSheetsModule], declarations: [AppComponent], exports: [AppComponent], bootstrap: [AppComponent] }) export class AppModule { } enableProdMode(); // Bootstrap application with hash style navigation and global services. platformBrowserDynamic().bootstrapModule(AppModule);
<!doctype html> <html style="height:100%;font-size:14px;"> <head> <meta charset="utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0" /> <link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/angular/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css"> <!-- Polyfills --> <script src="$DEMOROOT$/en/angular/node_modules/core-js/client/shim.min.js"></script> <script src="$DEMOROOT$/en/angular/node_modules/zone.js/fesm2015/zone.min.js"></script> <!-- SystemJS --> <script src="$DEMOROOT$/en/angular/node_modules/systemjs/dist/system.js"></script> <script src="systemjs.config.js"></script> <script> // workaround to load 'rxjs/operators' from the rxjs bundle System.import('rxjs').then(function (m) { System.import('@angular/compiler'); System.set(SystemJS.resolveSync('rxjs/operators'), System.newModule(m.operators)); System.import('$DEMOROOT$/en/lib/angular/license.ts'); System.import('./src/app.component'); }); </script> </head> <body> <app-component></app-component> </body> </html>
<div class="sample-tutorial"> <gc-spread-sheets [hostStyle]="hostStyle" (workbookInitialized)="initSpread($event)"> </gc-spread-sheets> </div>
.sample-tutorial { position: relative; width: 100%; height: 100%; overflow: hidden; } body { position: absolute; top: 0; bottom: 0; left: 0; right: 0; }
(function (global) { System.config({ transpiler: 'ts', typescriptOptions: { tsconfig: true }, meta: { 'typescript': { "exports": "ts" }, '*.css': { loader: 'css' } }, paths: { // paths serve as alias 'npm:': 'node_modules/' }, // map tells the System loader where to look for things map: { 'core-js': 'npm:core-js/client/shim.min.js', 'zone': 'npm:zone.js/fesm2015/zone.min.js', 'rxjs': 'npm:rxjs/dist/bundles/rxjs.umd.min.js', '@angular/core': 'npm:@angular/core/fesm2022', '@angular/common': 'npm:@angular/common/fesm2022/common.mjs', '@angular/compiler': 'npm:@angular/compiler/fesm2022/compiler.mjs', '@angular/platform-browser': 'npm:@angular/platform-browser/fesm2022/platform-browser.mjs', '@angular/platform-browser-dynamic': 'npm:@angular/platform-browser-dynamic/fesm2022/platform-browser-dynamic.mjs', '@angular/common/http': 'npm:@angular/common/fesm2022/http.mjs', '@angular/router': 'npm:@angular/router/fesm2022/router.mjs', '@angular/forms': 'npm:@angular/forms/fesm2022/forms.mjs', 'jszip': 'npm:jszip/dist/jszip.min.js', 'typescript': 'npm:typescript/lib/typescript.js', 'ts': './plugin.js', 'tslib':'npm:tslib/tslib.js', 'css': 'npm:systemjs-plugin-css/css.js', 'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js', 'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js', '@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js', '@mescius/spread-sheets-angular': 'npm:@mescius/spread-sheets-angular/fesm2020/mescius-spread-sheets-angular.mjs', '@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js' }, // packages tells the System loader how to load when no filename and/or no extension packages: { src: { defaultExtension: 'ts' }, rxjs: { defaultExtension: 'js' }, "node_modules": { defaultExtension: 'js' }, "node_modules/@angular": { defaultExtension: 'mjs' }, "@mescius/spread-sheets-angular": { defaultExtension: 'mjs' }, '@angular/core': { defaultExtension: 'mjs', main: 'core.mjs' } } }); })(this);